
COMMENT	#

	This file is a part of OOG package by MazeGen
	- for more info read oog.txt

	OOG MACRO itself

	#

.RADIX 16

LDi		EQU <099,0b1,0d2,0f3>	; Long Disp
SDi		EQU <090,0dc>		; Short Disp
BDi		EQU <080>		; Byte Disp

LIm		EQU <09a,0bb,0dc,0fd>	; Long Imm
SIm		EQU <091,0dd>		; Short Imm
BIm		EQU <081>		; Byte Imm

; Arguments:
;  Literal	literal string; when OOG_CREATE_DATA is defined, inserted in
;		current .data section
;  Opcode	instruction opcode
;  Opcode66_	instruction opcode following prefix 66h operand-size override;
;		not requied when this prefix has no influence on opcode
;  Opcode67_	similar to Opcode66_
;  Opcode66_67_ similar to Opcode66_; used rarely

OOG MACRO Literal:REQ, Opcode:REQ, Opcode66_, Opcode67_, Opcode66_67_

 LOCAL datalabel

IFDEF OOG_CREATE_DATA
 DATA SEGMENT
 CurrentText CATSTR <BYTE ">,<Literal>,<",0>
 datalabel	CurrentText
 DATA ENDS
ENDIF

;; There is no code or other segment - produced code bytes may
;; be placed anywhere

BYTE	Opcode			;; put the pure opcode at the beginning

Opcode66 CATSTR <Opcode66_>
IFNB <Opcode66_>		;; here has to be used the original argument
 BYTE	66, Opcode66		;; here has to be used CATSTR'ed argument
ELSE
 Opcode66 CATSTR <Opcode>	;; if Opcode66_ is blank, use Opcode instead
ENDIF

Opcode67 CATSTR <Opcode67_>
IFNB <Opcode67_>
 BYTE	67, Opcode67
ELSE
 Opcode67 CATSTR <Opcode>	;; if Opcode67_ is blank, use Opcode instead,
ENDIF				;; not Opcode66_, it would be not correct!

Opcode66_67 CATSTR <Opcode66_67_>
IFNB <Opcode66_67_>
 BYTE	66, 67, Opcode66_67
ELSE				;; if Opcode66_67_ is blank and
 IFNB <Opcode67_>		;;    if Opcode67_ is not blank, use it
  Opcode66_67 CATSTR <Opcode67>
 ELSEIFNB  <Opcode66_>		;;    elseif Opcode66_ is not blank, use it
  Opcode66_67 CATSTR <Opcode66>
 ELSE
  Opcode66_67 CATSTR <Opcode>	;;    else use the Opcode
 ENDIF				;; (only such order is correct)
ENDIF

IF NOT With26 EQ 0
 BYTE	26, Opcode
ENDIF
IF NOT With2E EQ 0
 BYTE	2E, Opcode
ENDIF
IF NOT With36 EQ 0
 BYTE	36, Opcode
ENDIF
IF NOT With3E EQ 0
 BYTE	3E, Opcode
ENDIF
IF NOT With64 EQ 0
 BYTE	64, Opcode
ENDIF
IF NOT With65 EQ 0
 BYTE	65, Opcode
ENDIF
IF NOT With66 EQ 0
 BYTE	66, Opcode66
ENDIF
IF NOT With67 EQ 0
 BYTE	67, Opcode67
ENDIF
IF NOT WithF0 EQ 0
 BYTE	0F0, Opcode
ENDIF
IF NOT WithF2 EQ 0
 BYTE	0F2, Opcode
ENDIF
IF NOT WithF3 EQ 0
 BYTE	0F3, Opcode
ENDIF
IF NOT With6667 EQ 0
 BYTE	66, 67, Opcode66_67
ENDIF
IF NOT With656667 EQ 0
 BYTE	65, 66, 67, Opcode66_67
ENDIF
 BYTE	90			;; mark the block off using NOP
ENDM

;*** Default settings

With26		= 1		; ES:
With2E		= 1		; CS:
With36		= 1		; SS:
With3E		= 1		; DS:
With64		= 1		; FS:
With65		= 1		; GS:
With66		= 1		; Operand-size override prefix
With67		= 1		; Address-size override prefix
WithF0		= 1		; LOCK
WithF2		= 1		; REPNE
WithF3		= 1		; REP, REPE

With6667	= 1
With656667	= 1