
COMMENT	#

	This file is a part of OOG package by MazeGen
	- for more info read oog.txt

	The ModR/M and SIB bytes are incremented by 1, starting from
	last used values in one_byte_no_fpu.tst:
	Last used ModR/M = 035
	Last uesed SIB = 013

	In instructions groups (where the reg/opcode field is an opcode)
	are used independent values of the ModR/M byte, but this is not
	a rule

	#

; SLDT and STR are listed additionally with Mod=11 because of extraordinary
; operand r16/32/m16
OOG <SLDT WORD PTR [EAX]; [BX+SI] >,<00F,000,00000000y>
OOG <SLDT eAX                     >,<00F,000,11000000y>
OOG <STR  WORD PTR [ECX]; [BX+DI] >,<00F,000,00001001y>
OOG <STR  eCX                     >,<00F,000,11001001y>
OOG <LLDT WORD PTR [EDX]; [BP+SI] >,<00F,000,00010010y>
OOG <LTR  WORD PTR [EBX]; [BP+DI] >,<00F,000,00011011y>
OOG <VERR WORD PTR [ESP+EDX]; [SI]>,<00F,000,00100100y,014>,<>,<00F,000,00100100y>
OOG <VERW WORD PTR [disp32]; [DI] >,<00F,000,00101101y,LDi>,<>,<00F,000,00101101y>

; SMSW listed additionally with Mod=11 because of extraordinary
; operand r16/32/m16
OOG <SGDT FWORD PTR [EAX]; [BX+SI] >,<00F,001,00000000y>
OOG <SIDT FWORD PTR [ECX]; [BX+DI] >,<00F,001,00001001y>
OOG <LGDT FWORD PTR [EDX]; [BP+SI] >,<00F,001,00010010y>
OOG <LIDT FWORD PTR [EBX]; [BP+DI] >,<00F,001,00011011y>
OOG <SMSW WORD PTR  [disp32]; [SI] >,<00F,001,00100100y,015,LDi>,<>,<00F,001,00100100y>
OOG <SMSW eSP                      >,<00F,001,11100100y>
OOG <LMSW WORD PTR  [ESI]; [disp16]>,<00F,001,00110110y>,        <>,<00F,001,00110110y,SDi>
OOG <INVLPG         [EDI]; [BX]    >,<00F,001,00111111y>

OOG <LAR eSI,[ESI]; [disp16]>,<00F,002,036>,<>,<00F,002,036,SDi>
OOG <LSL eSI,[EDI]; [BX]    >,<00F,003,037>

OOG <CLTS>,<00F,006>

OOG <INVD>,  <00F,008>
OOG <WBINVD>,<00F,009>

; because only CR0, CR2, CR3 a CR4 are allowed, ModR/M is not incremented
; and is set accordingly
OOG <MOV EAX,CR0>,<00F,020,11000000y>
OOG <MOV ECX,DR0>,<00F,021,11000001y>

OOG <MOV CR0,EDX>,<00F,022,11000010y>
OOG <MOV CR2,EDX>,<00F,022,11010010y>	; some extra testing needed
OOG <MOV DR0,EBX>,<00F,023,11000011y>

; Here may incrementing ModR/M continue
OOG <MOV EAX,TR7>,<00F,024,00111000y>	; test with Mod<>11 needed
OOG <MOV TR7,ECX>,<00F,026,00111001y>

OOG <WRMSR>,<00F,030>

OOG <RDTSC>,<00F,031>
OOG <RDMSR>,<00F,032>
OOG <RDPMC>,<00F,033>

OOG <CMOVO     eDI,[EDX]          ; [BP+SI] >,     <00F,040,03A>
OOG <CMOVNO    eDI,[EBX]          ; [BP+DI] >,     <00F,041,03B>
OOG <CMOVB_NAE eDI,[ESI+EDX]      ; [SI]    >,     <00F,042,03C,016>,<>,<00F,042,03C>
OOG <CMOVNB_AE eDI,[disp32]       ; [DI]    >,     <00F,043,03D,LDi>,<>,<00F,043,03D>
OOG <CMOVE_Z   eDI,[ESI]          ; [disp16]>,     <00F,044,03E>,    <>,<00F,044,03E,SDi>
OOG <CMOVNE_NZ eDI,[EDI]          ; [BX]    >,     <00F,045,03F>
OOG <CMOVBE_NA eAX,[EAX+disp8]    ; [BX+SI+disp8]>,<00F,046,040,BDi>
OOG <CMOVNBE_A eAX,[ECX+disp8]    ; [BX+DI+disp8]>,<00F,047,041,BDi>
OOG <CMOVS     eAX,[EDX+disp8]    ; [BP+SI+disp8]>,<00F,048,042,BDi>
OOG <CMOVNS    eAX,[EBX+disp8]    ; [BP+DI+disp8]>,<00F,049,043,BDi>
OOG <CMOVP_PE  eAX,[EDI+EDX+disp8]; [SI+disp8]   >,<00F,04A,044,017,BDi>,<>,<00F,04A,044,BDi>
OOG <CMOVNP_PO eAX,[EBP+disp8]    ; [DI+disp8]   >,<00F,04B,045,BDi>
OOG <CMOVL_NGE eAX,[ESI+disp8]    ; [BP+disp8]   >,<00F,04C,046,BDi>
OOG <CMOVNL_GE eAX,[EDI+disp8]    ; [BX+disp8]   >,<00F,04D,047,BDi>
OOG <CMOVLE_NG eCX,[EAX+disp8]    ; [BX+SI+disp8]>,<00F,04E,048,BDi>
OOG <CMOVNLE_G eCX,[ECX+disp8]    ; [BX+DI+disp8]>,<00F,04F,049,BDi>

OOG <JO     rel32; rel16>,<00F,080,LDi>,<00F,080,SDi>
OOG <JNO    rel32; rel16>,<00F,081,LDi>,<00F,081,SDi>
OOG <JB_NAE rel32; rel16>,<00F,082,LDi>,<00F,082,SDi>
OOG <JNB_AE rel32; rel16>,<00F,083,LDi>,<00F,083,SDi>
OOG <JE_Z   rel32; rel16>,<00F,084,LDi>,<00F,084,SDi>
OOG <JNE_NZ rel32; rel16>,<00F,085,LDi>,<00F,085,SDi>
OOG <JBE_NA rel32; rel16>,<00F,086,LDi>,<00F,086,SDi>
OOG <JNBE_A rel32; rel16>,<00F,087,LDi>,<00F,087,SDi>
OOG <JS     rel32; rel16>,<00F,088,LDi>,<00F,088,SDi>
OOG <JNS    rel32; rel16>,<00F,089,LDi>,<00F,089,SDi>
OOG <JP_PE  rel32; rel16>,<00F,08A,LDi>,<00F,08A,SDi>
OOG <JNP_PO rel32; rel16>,<00F,08B,LDi>,<00F,08B,SDi>
OOG <JL_NGE rel32; rel16>,<00F,08C,LDi>,<00F,08C,SDi>
OOG <JNL_GE rel32; rel16>,<00F,08D,LDi>,<00F,08D,SDi>
OOG <JLE_NG rel32; rel16>,<00F,08E,LDi>,<00F,08E,SDi>
OOG <JNLE_G rel32; rel16>,<00F,08F,LDi>,<00F,08F,SDi>

OOG <SETO     [EDX+disp8]    ; [BP+SI+disp8]>,<00F,090,04A,BDi>
OOG <SETNO    [EBX+disp8]    ; [BP+DI+disp8]>,<00F,091,04B,BDi>
OOG <SETB_NAE [EAX+EBX+disp8]; [SI+disp8]   >,<00F,092,04C,018,BDi>,<>,<00F,092,04C,BDi>
OOG <SETNB_AE [EBP+disp8]    ; [DI+disp8]   >,<00F,093,04D,BDi>
OOG <SETE_Z   [ESI+disp8]    ; [BP+disp8]   >,<00F,094,04E,BDi>
OOG <SETNE_NZ [EDI+disp8]    ; [BX+disp8]   >,<00F,095,04F,BDi>
OOG <SETBE_NA [EAX+disp8]    ; [BX+SI+disp8]>,<00F,096,050,BDi>
OOG <SETNBE_A [ECX+disp8]    ; [BX+DI+disp8]>,<00F,097,051,BDi>
OOG <SETS     [EDX+disp8]    ; [BP+SI+disp8]>,<00F,098,052,BDi>
OOG <SETNS    [EBX+disp8]    ; [BP+DI+disp8]>,<00F,099,053,BDi>
OOG <SETP_PE  [ECX+EBX+disp8]; [SI+disp8]   >,<00F,09A,054,019,BDi>,<>,<00F,09A,054,BDi>
OOG <SETNP_PO [EBP+disp8]    ; [DI+disp8]   >,<00F,09B,055,BDi>
OOG <SETL_NGE [ESI+disp8]    ; [BP+disp8]   >,<00F,09C,056,BDi>
OOG <SETNL_GE [EDI+disp8]    ; [BX+disp8]   >,<00F,09D,057,BDi>
OOG <SETLE_NG [EAX+disp8]    ; [BX+SI+disp8]>,<00F,09E,058,BDi>
OOG <SETNLE_G [ECX+disp8]    ; [BX+DI+disp8]>,<00F,09F,059,BDi>

OOG <PUSH FS>,<00F,0A0>
OOG <POP FS>, <00F,0A1>

OOG <CPUID>,<00F,0A2>

OOG <BT [EDX+disp8],eBX; [BP+SI+disp8],eBX>,<00F,0A3,05A,BDi>

OOG <SHLD [EBX+disp8],eBX,imm8  ; [BP+DI+disp8]>,<00F,0A4,05B,BDi,BIm>
OOG <SHLD [EDX+EBX+disp8],eBX,CL; [SI+disp8]   >,<00F,0A5,05C,01A,BDi>,<>,<00F,0A5,05C,BDi>

OOG <PUSH GS>,<00F,0A8>
OOG <POP GS>, <00F,0A9>

OOG <BTS [EBP+disp8],eBX; [DI+disp8],eBX>,<00F,0AB,05D,BDi>

OOG <SHRD [ESI+disp8],eBX,imm8; [BP+disp8]>,<00F,0AC,05E,BDi,BIm>
OOG <SHRD [EDI+disp8],eBX,CL  ; [BX+disp8]>,<00F,0AD,05F,BDi>

OOG <IMUL eSP,[EAX+disp8]; [BX+SI+disp8]>,<00F,0AF,060,BDi>

OOG <CMPXCHG [ECX+disp8],AH ; [BX+DI],AH >,<00F,0B0,061,BDi>
OOG <CMPXCHG [EDX+disp8],eSP; [BP+SI],eSP>,<00F,0B1,062,BDi>
OOG <CMPXCHG eDX,eSP>,                     <00F,0B1,0E2>	; test with Mod=11 needed

OOG <LSS eSP,F/DWORD PTR [EBX+disp8]; [BP+DI+disp8]>,<00F,0B2,063,BDi>

OOG <BTR [EBX+EBX+disp8],eSP; [SI+disp8],eSP>,<00F,0B3,064,01B,BDi>,<>,<00F,0B3,064,BDi>

OOG <LFS eSP,F/DWORD PTR [EBP+disp8]; [DI+disp8]>,<00F,0B4,065,BDi>
OOG <LGS eSP,F/DWORD PTR [ESI+disp8]; [BP+disp8]>,<00F,0B5,066,BDi>

OOG <MOVZX eSP,BYTE PTR [EDI+disp8]; [BP+disp8]   >,<00F,0B6,067,BDi>
OOG <MOVZX eBP,WORD PTR [EAX+disp8]; [BX+SI+disp8]>,<00F,0B7,068,BDi>
OOG <MOVZX eSP,BH>,                                 <00F,0B6,0E7>	; test with Mod=11 needed
OOG <MOVZX eBP,AX>,                                 <00F,0B7,0E8>	; test with Mod=11 needed

; used 061,06A,073,07C instead of 069-06C - they have the same r/m and Mod field
OOG <BT  DWORD PTR [ECX+disp8],imm8    ; [BX+DI+disp8],imm8>,<00F,0BA,061,BDi,BIm>
OOG <BTS DWORD PTR [EDX+disp8],imm8    ; [BP+SI+disp8],imm8>,<00F,0BA,06A,BDi,BIm>
OOG <BTR DWORD PTR [EBX+disp8],imm8    ; [BP+DI+disp8],imm8>,<00F,0BA,073,BDi,BIm>
OOG <BTC DWORD PTR [ESP+EBX+disp8],imm8; [SI+disp8],imm8   >,<00F,0BA,07C,01C,BDi,BIm>,<>,<00F,0BA,7C,BDi,BIm>

OOG <BTC [EBP+disp8],eBP; [DI+disp8],eBP>,<00F,0BB,06D,BDi>

OOG <BSF eBP,[ESI+disp8]; [BP+disp8]>,<00F,0BC,06E,BDi>
OOG <BSR eBP,[EDI+disp8]; [BX+disp8]>,<00F,0BD,06F,BDi>

OOG <MOVSX eSI,BYTE PTR [EAX+disp8]; [BX+SI+disp8]>,<00F,0BE,070,BDi>
OOG <MOVSX eSI,WORD PTR [ECX+disp8]; [BX+DI+disp8]>,<00F,0BF,071,BDi>

OOG <XADD [EDX+disp8],DH ; [BP+SI],DH >,<00F,0C0,072,BDi>
OOG <XADD [EBX+disp8],eSI; [BP+DI],eSI>,<00F,0C1,073,BDi>

; used 04C (01001100y) instead of 074 - it has the same r/m and Mod field
OOG <CMPXCHG8B QWORD PTR [EBP+EBX+disp8]; [SI+disp8]>,<00F,0C7,01001100y,01D,BDi>,<>,<00F,0C7,01001100y,BDi>

OOG <BSWAP eAX>,<00F,0C8>
OOG <BSWAP eCX>,<00F,0C9>
OOG <BSWAP eDX>,<00F,0CA>
OOG <BSWAP eBX>,<00F,0CB>
OOG <BSWAP eSP>,<00F,0CC>
OOG <BSWAP eBP>,<00F,0CD>
OOG <BSWAP eSI>,<00F,0CE>
OOG <BSWAP eDI>,<00F,0CF>
